///
// Fnugry Mouse Notify
// Copyright (C) 1997-98 Gleb Yourchenko
//
// System Wide Mouse Hook library
// Version 1.1.0.0
// 

/*
     Revision history

     1.1.0.0     22,apr,1998 Gleb Yourchenko
                 Hook procedure changed to process SendMessage result
                 and return TRUE value in case at least one client 
                 has returned  non-zero result. 


*/


#include <windows.h>
#include "fngmhlib.h"


//
// DLL Function Declarations
//

BOOL	CALLBACK LibMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved);
int 	CALLBACK WEP (int bSystemExit);
LRESULT CALLBACK MouseFunc (int nCode, WPARAM wParam, LPARAM lParam );


//
// DLL Data
//

HANDLE hInstance;

//
// Shared Data
//

HHOOK	hhookMouseHook       = 0;

#pragma data_seg("SHARDATA")
#pragma bss_seg("SHARDATA")

HWND	hwndUserWindow[MAX_NOTIFY_USER];
UINT	uintUserMessage[MAX_NOTIFY_USER];
int		cUserCount				= 0;

MOUSEHOOKSTRUCT mhsInfo;


#pragma data_seg()


//
//
//

BOOL CALLBACK LibMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
	hInstance = hModule;
    return 1;
}


int CALLBACK WEP (int bSystemExit)
{
    return(1);
}



LRESULT CALLBACK MouseFunc (int nCode, WPARAM wParam, LPARAM lParam )
{
	int i;
	BOOL discard = FALSE;
    if ( nCode >= 0 ) {
		if ( lParam ) {
			memcpy( &mhsInfo, (LPMOUSEHOOKSTRUCT)lParam , sizeof MOUSEHOOKSTRUCT );
		}
		else {
			memset( &mhsInfo, 0, sizeof MOUSEHOOKSTRUCT );
		}
		for ( i = 0; i < cUserCount; i++ ) {
			discard = ( discard || SendMessage( hwndUserWindow[i], uintUserMessage[i], wParam, (LPARAM) &mhsInfo ) );
		}
		return( discard );
	};
	return( CallNextHookEx(hhookMouseHook, nCode, wParam, lParam) );
}



int CALLBACK InstallMouseHook(HWND hwnd, UINT uintMsg)
{
	
	if ( cUserCount < MAX_NOTIFY_USER ) {

		if ( ! hhookMouseHook ) {
			hhookMouseHook = SetWindowsHookEx(WH_MOUSE, (HOOKPROC) MouseFunc, GetModuleHandle("fngmhlib.dll"), 0);
			if ( ! hhookMouseHook ) return(-1);
		}

		hwndUserWindow[cUserCount] = hwnd;
		uintUserMessage[cUserCount] = uintMsg;
		return(cUserCount++);
	} 
	else {
		SetLastError(ERROR_OUTOFMEMORY);
		return(-1);
	}
}

BOOL CALLBACK UninstallMouseHook(HWND hwnd)
{
	int HookIndex = -1;
	int i;

	for ( i = 0; i < cUserCount; i++ ) {
		if ( hwndUserWindow[i] == hwnd ) {
			HookIndex = i;
			break;
		}
	}


	if ( HookIndex >= 0 ) {

		if ( --cUserCount != HookIndex ) {
			hwndUserWindow[HookIndex] = hwndUserWindow[cUserCount];
			uintUserMessage[HookIndex] = uintUserMessage[cUserCount];
		}
		if ( ! cUserCount ) {
			UnhookWindowsHookEx(hhookMouseHook);
			hhookMouseHook = NULL;
		}
		return(TRUE);
	}
	else {
		SetLastError(ERROR_INVALID_HANDLE);
		return(FALSE);
	}
}
