(*
   Fnugry Mouse Hook Library
   Version 1.0
   Copyright(C) 1997-98 Gleb Yourchenko

   Pascal Import Unit
   Version 1.0.0.0

   Contact:
   Gleb Yourchenko
   eip__@hotmail.com

*)


{$define DynamicLink}

unit fngmhlib;

interface
uses
   Windows;

function InstallMouseHook(hwnd :HWND; uintMessage :Cardinal):Integer; stdcall;
function UninstallMouseHook(hwnd :HWND):Bool; stdcall;


implementation

const

  HookLibName = 'FNGMHLIB';

{$ifdef DynamicLink}

type

   TInstallMouseHookProc = function(hwnd :HWND;
      uintMessage :Cardinal):Integer; stdcall;

   TUninstallMouseHookProc = function(hwnd :HWND):Bool; stdcall;


var

   hlibMouseHookLib :THandle = 0;

   lpfnInstallMouseHook :TInstallMouseHookProc = Nil;
   lpfnUninstallMouseHook :TUninstallMouseHookProc = Nil;


function InstallMouseHook(hwnd :HWND; uintMessage :Cardinal):Integer;
begin
  result := -1;
  if assigned(lpfnInstallMouseHook) then
     result := lpfnInstallMouseHook(hwnd, uintMessage);
end;

function UninstallMouseHook(hwnd :HWND):Bool;
begin
  result := false;
  if assigned(lpfnUninstallMouseHook) then
     result := lpfnUninstallMouseHook(hwnd);
end;

{$else}

function InstallMouseHook;                 external HookLibName index 2;
function UninstallMouseHook;               external HookLibName index 3;

{$endif}

{$ifdef DynamicLink}

initialization
   hlibMouseHookLib := LoadLibrary(HookLibName);
   if hlibMouseHookLib <> 0 then
      begin
        lpfnInstallMouseHook := GetProcAddress(hlibMouseHookLib, 'InstallMouseHook');
        lpfnUninstallMouseHook := GetProcAddress(hlibMouseHookLib, 'UninstallMouseHook');
      end
   else
      begin
        MessageBox(0, 'Could not load DLL: '+HookLibName, 'Error',
          MB_OK OR MB_ICONHAND);
        ExitCode := -1
      end;
finalization
   FreeLibrary(hlibMouseHookLib);

{$endif}

end.

