unit test_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FngMouseNtfy, StdCtrls;

type
  TMainForm = class(TForm)
    Memo: TMemo;
    Button1: TButton;
    Button2: TButton;
    StatusLbl: TLabel;
    MouseNotify: TFnugryMouseNotify;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure MouseNotifyChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MouseNotifyMouseMessage(Sender: TObject; Msg: Integer;
      lpInfo: PMouseHookStruct; var fDiscard: Boolean);
  private
     procedure UpdateStatus;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.Button1Click(Sender: TObject);
begin
   MouseNotify.Enabled := not MouseNotify.Enabled;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  Close;
end;



procedure TMainForm.MouseNotifyChange(Sender: TObject);
begin
   UpdateStatus;
end;

procedure TMainForm.UpdateStatus;
begin
  if MouseNotify.Enabled then
     StatusLbl.Caption := 'Active'
  else
     StatusLbl.Caption := 'Disabled';
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
   UpdateStatus;
end;

procedure TMainForm.MouseNotifyMouseMessage(Sender: TObject;
  Msg: Integer; lpInfo: PMouseHookStruct; var fDiscard: Boolean);
var
  x, y :integer;
begin
   x := 0;
   y := 0;
   if assigned(lpinfo) then
      begin
        x := lpInfo^.pt.x;
        y := lpInfo^.pt.y;
      end;
   memo.lines.add(format('[%s] %d (%d:%d)',
     [formatDateTime('hh:nn:ss', now), Msg, x, y]));
   fDiscard := (x < 100) and (y < 100);
end;

end.
